button =
{

	x=0,				--button collision is in squares
	y=0,
	w=0,
	h=0,
	name="",						--name to display the button with
	state="default",			--"default", "selected", "active"; ex: "selected" when mouse is over button
	selected=nil				--value that must match in order to say the button is selected
	
}
button.__index = button



function button:new(variables)

	variables=variables or {}
	local self=setmetatable(variables,self)
	return self

end



function button:update(input,selected_id,ix,iy)		--updates the state

	ix=ix or nil
	iy=iy or nil
	input=input or false
	selected_id=selected_id or nil
	if ix~=nil and iy~=nil then			--used for mouse
	
		if checkRectangleCollision(self,createRectangle(ix,iy,1,1)) then		--coordinates are over collision rectangle
		
			if input==true then self.state="active"
			else self.state="selected" end
		
		else self.state="default" end
		
	else

		if selected_id==self.selected then
		
			if input==true then self.state="active"
			else self.state="selected" end
			
		else self.state="default" end
		
	end
	
end



function button:draw()

	love.graphics.rectangle("fill",self.x,self.y,self.w,self.h)
	love.graphics.print(self.name,self.x+5,self.y+5)
	love.graphics.print(tostring(self.selected),self.x+200,self.y+5)

end