entity = 
{

	x=0.000,
	y=0.000,
	current_sprite=1,
	current_collision=1,				--says what set of collision rects the entity is currently on
	class = {},					--says what class of object this entity is: REQUIRED; a table
	id=nil
	
}
entity.__index = entity



function entity:new(variables)

	variables=variables or {}
	variables._oldx=variables.x or 0.000
	variables._oldy=variables.y or 0.000
	variables.class=variables.class or {}
	
	local self=setmetatable(variables,self)
	self:runScript("create")
	
	return self

end



function entity:drawSelf(display_x, display_y, scale_x, scale_y)

	scale_x=scale_x or 1
	scale_y=scale_y or scale_x
	if self.class.sprite_quads[self.currentsprite]~=nil then
	love.graphics.draw(self.class.spritesheet, self.class.sprite_quads[self.currentsprite], display_x, display_y, 0, scale_x, scale_y, 0, 0, 0, 0) end
	--else print("Error: sprite_quads[" .. self.currentsprite .. "] is null") end

end



--[[function entity:getRelRect()

	return createRectangle(self.x,self.y,self.class._boundingBox_collision[self.current_collision].w,self.class._boundingBox_collision[self.current_collision].h)

end--]]



function entity:runScript(script_name,...)

	if self[name]~=nil then return nil				--function name doesn't exist; only time nil is returned for success
	elseif script_name=="draw" then love.graphics.setColor(255,255,255,255)
	elseif script_name=="destroy" then return nil end									--won't run destroy script (will crash the game)
	
	local err=nil			--the actual error
	local success=nil		--whether or not the function could be properly ran
	success,err=pcall(self.class.script[script_name],self,...)
	
	return success,err		--return whether successful and the error

end



--[[function entity:checkCollision(collided_obj)

	if checkRectangleCollision(self:getRelRect(),collided_obj:getRelRect()) then
	--check if it is possible if there could be a collision; if so...

		local self_rect={}			--create relative rectangles
		local other_rect={}

		for i=1,table.getn(self.class.collision_rects[self.current_collision].rectangles),1 do
		
			self_rect={
				
				x=self.x+self.class.collision_rects[self.current_collision].rectangles[i].x,			--values won't change if there's no movement
				y=self.y+self.class.collision_rects[self.current_collision].rectangles[i].y,
				w=self.class.collision_rects[self.current_collision].rectangles[i].w,
				h=self.class.collision_rects[self.current_collision].rectangles[i].h
				
			}
			for v=1,table.getn(collided_obj.class.collision_rects[collided_obj.current_collision].rectangles) do
			
				other_rect={
				
					x=collided_obj.x+collided_obj.class.collision_rects[collided_obj.current_collision].rectangles[i].x,			--values won't change if there's no movement
					y=collided_obj.y+collided_obj.class.collision_rects[collided_obj.current_collision].rectangles[i].y,
					w=collided_obj.class.collision_rects[collided_obj.current_collision].rectangles[i].w,
					h=collided_obj.class.collision_rects[collided_obj.current_collision].rectangles[i].h
				
				}
				--check all rectangles for a collision
				if checkRectangleCollision(self_rect,other_rect) then
				
					return true		--there is a collision
				
				end
			
			end
	
		end
		
	end
	return false 			--there is no collision

end



function entity:fixCollision(collided_obj,axis)			--handles the collision for self and the other entity
	
	local self_moved=nil
	local other_moved=nil
	
	--determine if the object actually moved, (used for determining how much to move objects back)
	if self.x~=self._oldx or self.y~=self._oldy then self_moved=true end
	if collided_obj.x~=collided_obj._oldx or collided_obj.y~=collided_obj._oldy then other_moved=true end
	
	if self_moved==true and other_moved==nil then				--self moved but collided_obj didn't
	
		--get the percentage for x and y of total movement (how much to move the object 1 pixel)
		local xspeed=math.abs(self.x-self._oldx)
		local yspeed=math.abs(self.y-self._oldy)
		local xrel=xspeed/(xspeed+yspeed)														--relative to one pixel
		local yrel=yspeed/(xspeed+yspeed)
		
		if self:getDirection('X')=="right" then xrel=-xrel end
		if self:getDirection('Y')=="down" then yrel=-yrel end
		
		while(true~=false) do
		
			self.x=self.x+xrel
			self.y=self.y+yrel
			if self:checkCollision(collided_obj)==false then break end
		
		end
	
	elseif self_moved==nil and other_moved==true then				--collided_obj moved but self didn't
	
	elseif self_moved==true and other_moved==true then
	
	else					--no one moved
	
		return false			--collision was unable to be fixed
	
	end
	
	return true				--collision was fixed

end



function entity:getDirection(axis)		--returns whether the object moved left, right, up, or down

	if axis=='X' then
	
		if self.x>self._oldx then return "right"
		
		elseif self.x<self._oldx then return "left"
		
		else return "none" end
	
	elseif axis=='Y' then
	
		if self.y>self._oldy then return "down"
		
		elseif self.y<self._oldy then return "up"
		
		else return "none" end
	
	else return nil end			--no axis was given

end



function entity:getAngle()			--gets the angle self moved

	getAngleFrom2Points(self._oldx,self._oldy,self.x,self.y)

end--]]



function entity:destroy()

	if pcall(self.class.script.destroy,self,"entity") then return true		--run class destroy script
	else return false end

	self.x=nil
	self.y=nil
	self.currentsprite=nil
	self.class=nil
	self.id=nil
	
	collectgarbage()				--remove vars from memory

end