gamestate =
{

	draw=nil,				--the variables are functions
	update=nil,
	init=nil,				--ran when gamestate is loaded (will run multiple times)
	exit=nil				--ran when the gamestate is changed to a different one (will run multiple times)
	
}
gamestate.__index = gamestate



function gamestate:new(variables)

	variables=variables or {}
	local self=setmetatable(variables,self)
	return self

end



function gamestate:runFunction(name,...)

	if self[name]==nil then return "FUNCTION_NAME: " .. tostring(name)				--function name doesn't exist
	elseif self.name=="draw" then love.graphics.setColor(255,255,255,255) end
	
	local args=... or {}
	local ret=self[name](self,args)		--game will crash if unable to run successfully!
	ret=ret or nil
	return ret
	

end



function gamestate:destroy()

	self.draw=nil
	self.update=nil
	self.init=nil
	self.exit=nil

end