menu =
{

	buttons={},					--stores multiple buttons classes
	update=nil,						--functions
	draw=nil
	
}
menu.__index = menu



function menu:new(variables)

	variables=variables or {}
	local self=setmetatable(variables,self)
	return self

end



function menu:sort()		--puts buttons in order of position

	local buttons_ordered={}				--stores the buttons
	for k, v in pairs(self.buttons) do
	
		table.insert(buttons_ordered,table.getn(buttons_ordered)+1,self.buttons[k])
	
	end
	
	table.sort(buttons_ordered,function(a,b) return a.y<b.y end)
	
	for i=1,table.getn(buttons_ordered),1 do
	
		buttons_ordered[i].selected=i
	
	end

end



function menu:draw()

	for k,v in pairs(self.buttons) do
	
		self.buttons[k]:draw()
	
	end

end



function menu:update(input,selected_id,ix,iy)			--returns what buttons have been pressed

	for k,v in pairs(self.buttons) do
	
		self.buttons[k]:update(input,selected_id,ix,iy)
	
	end

end