function love.load(args)

	-----------------------------------------
	--Get command line arguments--
	-----------------------------------------
	
	require "other/load_list"
	ext_files={}					--list of files modders have added
	allow_online=true			--whether to allow online capabilities or not
	
	local current_command="file"		--current command on for command line arguments
	local got_command=false			--used for loop
	local command_name=""			--used for loop; the name of the current command
	console_text={}						--temporarily stores all the console messages
	console_times={}					--times the errors were created
	
	allCommands={}				--stores the commands; the name of the variables are what must be entered on input
	allCommands=require("other/launch_commands")
	
	TEMP_addCText=function (string)				--temporary function for adding errors

		local time=love.timer.getTime()
		table.insert(console_text,table.getn(console_text)+1,string)
		table.insert(console_times,table.getn(console_times)+1,time )
	
	end
	
	for i=2,table.getn(args),1 do			--start at 2nd argument (first argument is game.love)

		if args[i]=="" then TEMP_addCText("No argument was entered!")		 --nothing entered so do nothing
		elseif string.sub(args[i],1,1)=="-" then
		
			command_name=string.sub(args[i],2,string.len(args[i]))
			for k, v in pairs(allCommands) do

				if command_name==k then
			
					current_command=k
					got_command=true
					break
			
				end
				
			end
				
		elseif string.sub(args[i],1,1)=="-" and got_command==false then					--dash found (used for commands), but no command
		
			TEMP_addCText("Command " .. args[i] ..  " not found")
		
		else			--run the command
		
			local err=nil
			local success=nil
			success,err=pcall(allCommands[command_name],args[i])
			if success==nil then TEMP_addCText("Command -" .. current_command .. " was unable to be properly executed;\n	ARG: " .. args[i] .. "\n	ERROR: " .. tostring(error)) end
		
		end
	
	end	
	
	
	
	---------------------------
	--Load external files--
	---------------------------
	
	if table.getn(ext_files)>0 then 		--check if any files have been found; continue if so
	
		TEMP_addCText("\nExecuting files:\n")
		for i=1,table.getn(ext_files),1 do			
	
			local err=nil
			local success=nil
			success,err=pcall(dofile,ext_files[i])
			if success==false then TEMP_addCText("	" .. ext_files[i] .. " was unable to be executed!\n		ERROR: " .. tostring(err))			--file could not be run
			else TEMP_addCText("	" .. ext_files[i] .. " successfully executed!") end					--file successfully ran
	
		end
		TEMP_addCText("")
		
	else TEMP_addCText("No files found!\n") end
	
	
	
	
	------------------------------------------
	--Run load list[1] and destroy it--
	------------------------------------------
	
	--run the first loadList subsection; this is due to the load time
	for v=1,table.getn(loadList.order[1]),1 do			--this is possible since the variable is equal to a table
		
		local err=nil			--the actual error
		local success=nil		--whether or not the function could be properly ran
		success,err=pcall(loadList.order[1][v])
		if success==false then TEMP_addCText(tostring(loadList.order[1]) .. " (var #" .. v .. ") was unable to properly execute!\n	ERROR: " .. tostring(err)) end
		loadList.order[1][v]=nil
		
	end
	table.remove(loadList.order,1)
	
	
	
	----------------------------
	--Print all arguments--
	----------------------------
	
	if table.getn(args)>1 then 			--print arguments if any exist
	
		print("Arguments:\n")
		for i=2,table.getn(args),1 do
	
			print("	" .. args[i],0)
	
		end
		print("",0)
		
	else print("No arguments exist!\n",0) end
	
	
	
	
	------------------------------------------------
	--Print all console text and destroy it--
	------------------------------------------------
	
	for i=1,table.getn(console_text),1 do
	
		print(console_text[i])
		--game.console()
		console_text[i]=nil
		console_times[i]=nil
	
	end
	console_text=nil
	console_times=nil
	
	TEMP_addCText=nil
	
	collectgarbage()
	
end
