function getAngleFrom2Points(x1,y1,x2,y2)

	local retvalue=math.atan2((y2-y1),(x2-x1))
	--retvalue=retvalue*180/math.pi
	return retvalue

end



function drawGAF2P_Triangle(x1,y1,x2,y2)

	love.graphics.setColor(0,0,255,255)
	love.graphics.line(x1,y1,x2,y1)
	love.graphics.setColor(0,255,0,255)
	love.graphics.line(x2,y1,x2,y2)
	love.graphics.setColor(255,0,0,255)
	love.graphics.line(x1,y1,x2,y2)
	love.graphics.setColor(255,255,0,255)
	love.graphics.circle("fill",x1,y1,3,16)
	love.graphics.setColor(255,255,255,255)

end



function replaceImage_Color(image, color2change, newcolor)		--color2change and newcolor are tables that include: r,g,b,a

	local image_data=image:getData()		--get the image data to change and get pixels
	local r,g,b,a=0			--used to store the current pixels
	
	for y=0,image:getHeight()-1,1 do			--keep looping for the image's height
	
		for x=0,image:getWidth()-1,1 do		--keep looping for the images width
		
			r,g,b,a=image_data:getPixel(x,y)
			if r==color2change.r and g==color2change.g and b==color2change.b and a==color2change.a then			--if the current pixel matches the desired color to change; then
			
				image_data:setPixel(x,y,newcolor.r,newcolor.g,newcolor.b,newcolor.a)			--change to the new color
			
			end
		
		end
	
	end
	
	image:refresh()				--update the image

end



function table.getn2(table)

	local count=0
	for k, v in pairs(table) do
	
		count=count+1
	
	end
	return count

end



function saveImage(image,...)

	local image_data=love.image.newImageData(image)
	return image_data:encode(...)

end


function printASCII_ids(text)

	local ids={}
	for i=1,string.len(text),1 do
	
		table.insert(ids,i,string.byte(text,i))
		
	end
	
	return ids

end



function getDistance(x1,x2,y1,y2)

	return math.abs(math.sqrt((math.pow((x2-x1),2)+math.pow((y2-y1),2))))				--uses distance formula

end



function getVariableName(...)

	vars={}
	vars=...
	ret=""
	
	for k,v in pairs(vars) do
	
		ret=ret .. k .. " "
	
	end
	
	ret=string.sub(ret,1,string.len(ret)-1)
	return ret

end



function fileExists(file_name)			--returns whether or not a file actually exists

	local tempfile=io.open(file_name,"r")
	if tempfile~=nil then
	
		io.close(tempfile)
		return true
		
	else return false end

end



function copyTable(table2copy,copy_metatable,twt,_ctwt)			--can copy tables within tables; twt set if to do that or not

	if type(table2copy)~='table' then return false end		--table2copy is not a table
	
	twt=twt or "all"			--a number that tells how many tables within tables within tables within tables.. to copy;
	_ctwt=_ctwt or 0					--a number that tracks how many tables within tables have been copied; private variable
	local returnTable = {}
	
	if getmetatable(table2copy)~=nil and copy_metatable then setmetatable(returnTable,table2copy) end		--copies the metatable if one exists
	
	for k,v in pairs(table2copy) do			--loop through all the variables
		
		if type(table2copy[k])=='table' then			--something special must be done if the variable is a table
		
			if (type(twt)=='number' and _ctwt<twt) or twt=="all" then			--checks if table copy limit is reached; if it isn't or copying all tables is set then continue
			
				_ctwt=_ctwt+1
				returnTable[k]=copyTable(table2copy[k],copy_metatable,twt,_ctwt)		--calls the function so tables within table within tables... can be found and returned
			
			else returnTable[k]=v end
		
		else returnTable[k]=v end			--no table, so it can be regularly copied
		
	end
	
	return returnTable

end



function getTableSize(table2get,twt,_ctwt)			--gets the amount of elements spread through all the tables

	if type(table2get)~='table' then return false end		--table2copy is not a table
	
	twt=twt or "all"			--a number that tells how many tables within tables within tables within tables.. to get;
	_ctwt=_ctwt or 0					--a number that tracks how many tables within tables have been gotten; private variable
	local var_amount=0
	
	for k,v in pairs(table2get) do			--loop through all the variables
		
		if type(table2get[k])=='table' then			--something special must be done if the variable is a table
		
			if (type(twt)=='number' and _ctwt<twt) or twt=="all" then			--checks if table copy limit is reached; if it isn't or copying all tables is set then continue
			
				var_amount=var_amount+getTableSize(table2get[k],twt,_ctwt+1)		--calls the function so tables within table within tables... can be found and returned
			
			else var_amount=var_amount+1 end
		
		else var_amount=var_amount+1 end			--no table, so it can be regularly copied
		
	end
	
	return var_amount

end



function mergeTables(tables2merge,merge_type,twt,_ctwt)

	tables2merge=tables2merge or nil
	merge_type=merge_type or "variable"					--"variable"=merge with variable names; "number"=merge without variable names and using 
	twt=twt or "all"								--how many sub-tables within sub-tables... to merge
	_ctwt=_ctwt or -1					--neg 1 becauuse it has to go within itself at the start
	if tables2merge==nil then return false end				--no tables found!
	local retTable={}
	local tempTable=tempTable or nil
	
	for k,v in pairs(tables2merge) do			--first find deepest table
		
		if type(tables2merge[k])=="table" and ((type(twt)=="number" and _ctwt<twt) or twt=="all") then
		--go deeper
			
			if tempTable==nil then tempTable={} end
			table.insert(tempTable,table.getn(tempTable)+1,mergeTables(tables2merge[k],merge_type,twt,_ctwt+1))
			
		end
			
	end

	if tempTable==nil then				--at deepest table
	
		return tables2merge
	
	else
	
		for i=1,table.getn(tempTable),1 do
		
			for k,v in pairs(tempTable[i]) do		--copy previous values
		
				if type(v)~="table" then retTable[k]=v end
		
			end
		
		end
		for k,v in pairs(tables2merge) do		--copy self table's values
		
			if type(v)~="table" then retTable[k]=v end
		
		end
	
	end
	
	return retTable

end



function printTable(table2print,twt,_ctwt,_spaceamount)

	if type(table2print)~='table' then return false end		--table2print is not a table
	twt=twt or "all"			--a number that tells how many tables within tables within tables within tables.. to copy;
	_ctwt=_ctwt or 0					--a number that tracks how many tables within tables have been copied; private variable
	_spaceamount=_spaceamount or 0

	local spacechars=""
			
	for p=1,_spaceamount,1 do
			
		spacechars=spacechars .. " "
			
	end
	
	for k,v in pairs(table2print) do			--loop through all the variables
		
		if type(table2print[k])=='table' and ((type(twt)=='number' and _ctwt<twt) or twt=="all") then
		--something special must be done if the variable is a table; also checks if table copy limit is reached; if it isn't or copying all tables is set then continue
			
			print(spacechars .. "TABLE: " .. k .. "\n" .. spacechars .. "{\n")
				
			printTable(table2print[k],twt,_ctwt+1,_spaceamount+2)		--calls the function so tables within table within tables... can be found and returned
				
			print("\n" .. spacechars .. "}")
			
		
		else print(spacechars .."TYPE=" .. type(table2print[k]) .. "	" .. k .. "=" .. tostring(v)) end			--no table, so it can be regularly copied
		
	end

end