alterEnemyList={}					--stores enemies to be added or freed to the game; enemies altered next frame

function handleCollision(self,collision_data,axis)



end



function addControl(name,display_name,default_input,local_player)

	local_player=local_player or "all"
	if string.sub(name,1,1)=="_" then local_player=1 end			--make _ controls added only to player 1
	
	if local_player=="all" then
	
		for i=1,table.getn(player),1 do

			player[i].controls[name]=control:new({name=display_name,input={default_input}})
	
		end
		
	else
		
		player[local_player].controls[name]=control:new({name=display_name,input={default_input}})
		
	end
	
	game.allControls[name]=control:new({name=display_name,input={default_input}})

end



function updateControls(local_player)				--makes so every player has controls set

	for i=1,table.getn(player),1 do
	
		for k, v in pairs(game.allControls) do
		
			if player[i].controls[k]==nil and string.sub(k,1,1)~="_" then player[i].controls[k]=control:new({name=game.allControls[k].name}) end			--the control is missing for player i; so add it
		
		end
	
	end

end



function checkControl(name,press_release,local_player)

	name=name or nil
	if name==nil then return "name" end			--name is not set
	local_player=local_player or 1
	press_release=press_release or true			--used to check whether or not to return press and released states; set true to use
	
	if press_release==true then return player[local_player].controls[name].state
	else
	
		if player[local_player].controls[name].state=="down" or "pressed" then return true
		else return false end
	
	end

end



function genInputString(input_type,input,hat_number,specific_dir)				--used to create strings for the controls input; such as "kup"

	--for axis; input becomes axis_num, hat_number becomes axis_pos, specific_dir becomes deadzone
	if input_type=="keyboard" then return "k" .. input
	elseif input_type=="mouse" then return "m" .. input
	elseif input_type=="hat" then
	
		if specific_dir==true then return "h" .. hat_number .. "z" .. input .. "s"
		else return "h" .. hat_number .. "z" .. input .. "a" end
	
	elseif input_type=="button" then return "b" .. input
	elseif input_type=="axis" then return "a" .. input .. "z" .. hat_number .. specific_dir
	else return "type" end			--returns that an incorrect input type was entered

end



function getInputString(input)					--breaks down an input string into a table with its properties

	input_number=input_number or 1
	if input==nil then return false end		--control not found
	
	local retTable={}
	local ascii=string.byte(input,1,1)
	
	if ascii==107 then				--"k"; from keyboard
	
		retTable.input_type="keyboard"
		retTable.input=string.sub(input,2,string.len(input))
	
	elseif ascii==106 then		--"j"; from joystick
	
		retTable.input_type="joystick"
		retTable.input=string.sub(input,2,string.len(input))
	
	elseif ascii==104 then		--"h"; from joystick hat; also returns hat_number,input,specific_direction
	
		local actual_control=string.sub(input,2,string.len(input))
		local hat_end=string.find(actual_control,"z")		--z marks the end of the hat number
	
		retTable.input_type="hat"
		retTable.hat_number=tonumber(string.sub(actual_control,1,hat_end-1))
		retTable.input=string.sub(actual_control,hat_end+1,string.len(actual_control)-1)
		retTable.specific_direction=false
		if string.sub(actual_control,string.len(actual_control),string.len(actual_control))=="s" then retTable.specific_direction=true end
	
	elseif ascii==109 then		--"m"; from mouse
	
		retTable.input_type="mouse"
		retTable.input=string.sub(input,2,string.len(input))
		
	elseif ascii==97 then				--"a"; from axis; also returns axis_pos, deadzone, and axis_value;; does NOT return input
	
		local actual_control=string.sub(input,2,string.len(input))
		local axis_end=string.find(actual_control,"z")
		
		retTable.input_type="axis"
		retTable.axis_num=string.sub(actual_control,1,axis_end-1)
		retTable.axis_pos=true
		if string.sub(actual_control,axis_end+1,axis_end+1)=="-" then retTable.axis_pos=false end
		retTable.deadzone=tonumber(string.sub(actual_control,axis_end+2,string.len(actual_control)))
			
		retTable.axis_value=joystick:getAxis(axis_num)			--the actual value of the axis on the joystick
	
	
	else return "type" end			--returns that the input type was not found
	
	return retTable

end



function setCamera(camera,camera_id,id_type)

	id_type=id_type or "pos"
	if id_type=="id" then
	elseif id_type=="pos" then
	else return "id_type" end

end



function addCamera(camera)

	if game.camera==nil then return false end			--camera not found
	if table.getn(game.camera)>=game.camera_maxamount then table.remove(game.camera,1) end
	table.insert(game.camera,table.getn(game.camera),camera)

end



function removeCamera(camera_id,id_type)

		id_type=id_type or "pos"		--"id" or "pos"
		
		if id_type=="id" then
		
			for i=1,table.getn(game.camera),1 do
		
				if game.camera[i].id==camera_id then
				
					return true
				
				end
		
			end
			return "id"		--id not found
			
		elseif id_type=="pos" then
		
			if game.camera[camera_id]==nil then return "pos"		--table position in camera doesn't exist
			else
			
				table.remove(game.camera,camera_id)
				return true			--camera was successfully removed
				
			end
		
		else return "id_type" end		--id_type doesn't have a correct value

end



function addGameScripts(script_list)

	

end



function addEnemy(arguments)

	table.insert(alterEnemyList,table.getn(alterEnemyList)+1,{args=arguments,todo="add"})

end



function removeEnemy(arguments)

	table.insert(alterEnemyList,table.getn(arlterEnemyList)+1,{args=arguments,todo="free"})

end



function changeGameState()

	if game.next_state~=nil then
	
		if game.current_state~=nil then game.current_state:runFunction("exit",game.cs_exitArgs) end
		game.current_state=game.next_state
		
		game.current_state:runFunction("init",game.ns_initArgs)
		
		game.ns_initArgs=nil
		game.cs_exitArgs=nil
		game.next_state=nil
		return true

	else return false end							--state doesn't exist
		
end



function setNextState(next_state,ns_args,exit_args)

	if next_state~=nil then
	
		game.next_state=next_state or game.next_state
		game.ns_initArgs=ns_args or game.ns_initArgs
		game.cs_exitArgs=exit_args or game.cs_exitArgs
		return true
	
	else return false end

end



function fitScreenSize(width,height,game_width,game_height,camera,flags)	--modifies camera to fit size

	if width<game_width or height<game_height then return false end			--screen size was too small
	camera.scaleX=math.min(math.floor(width/game_width),math.floor(height/game_height))
	camera.scaleY=camera.scaleX
	return love.window.setMode(width,height,flags)

end



--[[function drawCollisionRect(self,id,style)

	for i=1,table.getn(self.class.collision_rects[id].rectangles),1 do
	
		love.graphics.rectangle(style,math.floor(self.x),math.floor(self.y),self.class.collision_rects[id].rectangles[i].w,self.class.collision_rects[id].rectangles[i].h)
	
	end

end--]]