loadList={}				--variables must be functions!!!

loadList.core={}
loadList.core[1]= function ()			--load console/add game table

	game = {}
	game.console=custom_console:new()

	_print = print					--save old print
	
	--[[function print(string,custom_time)				--redefine print
	
		game.console:add(string,custom_time)
	
	end--]]
	TEMP_addCText("Console added")

end



loadList.core[2]= function ()			--load gamestates

	game.current_state=nil
	game.next_state=nil
	game.ns_initArgs=nil
	game.cs_exitArgs=nil
	game.allMenus=require("gamestates/assets/gamestate_menu_allMenus")
	game.menuUpdates=require("gamestates/assets/gamestate_menu_menuUpdates")
	game.menuDraws=require("gamestates/assets/gamestate_menu_menuDraws")
	state_load=require("gamestates/gamestate_load")
	state_save=require("gamestates/gamestate_save")
	state_play=require("gamestates/gamestate_play")
	state_menu=require("gamestates/gamestate_menu")
	state_screensaver=require("gamestates/gamestate_screensaver")
	state_load.title="Loading Game"
	TEMP_addCText("Load gamestate added")

end



loadList.core[3]= function ()			--merge loadList and change state to load

	local tempLoad={}
	for i=2,table.getn(loadList.order),1 do			--skip the first loadList table; is core
	
		for v=1,table.getn(loadList.order[i]),1 do
		
			table.insert(tempLoad,table.getn(tempLoad)+1,loadList.order[i][v])
		
		end
	
	end
	setNextState(state_load,{toLoad=tempLoad})
	changeGameState()
	setNextState(state_screensaver,{altState=state_menu,as_initArgs={controlling_player=1,current_menu="main",allMenus=game.allMenus,menuUpdates=game.menuUpdates,menuDraws=game.menuDraws}})
	TEMP_addCText("Gamestate changed to load: loadList")

end



loadList.core[4]= function ()			--setup screen

	game.width=320
	game.height=200
	game.menu_camera=camera:new({id="menu"})
	game.camera={}
	game.camera_maxamount=1
	game.current_camera=1
	addCamera(game.menu_camera)
	local testx,testy=love.window.getDesktopDimensions()
	--print("Screen size changed to: " .. testx/2 .. "x" .. testy/2)
	fitScreenSize(testx/2,testy/2,game.width,game.height,game.menu_camera)
	TEMP_addCText("Screen size changed to: " .. testx/2 .. "x" .. testy/2)

end



loadList.core[5]= function()			--add player

	player={}							--stores the players controls, entity, etc.
	player[1]={}
	player[1].entity=nil

end



loadList.core[6]= function ()			--setup controls

	game.allControls={}					--stores the every control added to the game; used to allow added players to easily have their controls added
	for i=1,table.getn(player),1 do
	
		player[i].controls={}					--whether the key is active or not
		player[i].joystick=nil						--tells what joystick is being used if one is being used
	
	end
	local test=love.joystick.getJoysticks()
	player[1].joystick=test[1]
	addControl("left","Move left","kleft")
	addControl("right","Move right","kright")
	addControl("up","Up","kup")
	addControl("down","Down","kdown")
	addControl("jump","Jump","k ")
	addControl("pause","Pause game","kp")
	addControl("enter","Enter","kreturn")
	
	addControl("_mouseLClick","ml","ml")			--if _ is set for control name it will not show when you try to edit controls
	addControl("_mouseRClick","mr","mr")
	addControl("_mouseMClick","mm","mm")
	TEMP_addCText("Core game controls added")

end



loadList.entities={}
loadList.entities[1]= function ()				--add game world

	game.world=world:new()
	state_load.title="World loaded"
	
end



loadList.entities[2]= function ()			--etc

	state_load.title="Etc. loaded"

end



loadList.order={}								--the order at which to load the subsections
loadList.order[1]=loadList.core			--variables store actual table pointer
loadList.order[2]=loadList.entities